/*
 * Copyright 2016 ELVEES NeoTek JSC
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

#ifndef _REGS_H_
#define _REGS_H_

#define CORE0_R0                           0x000
#define CORE0_R1                           0x010
#define CORE0_R2                           0x020
#define CORE0_R4                           0x040

#define CORE0_A0                           0x300
#define CORE0_A1                           0x304
#define CORE0_A2                           0x308
#define CORE0_A3                           0x30C
#define CORE0_A4                           0x310
#define CORE0_A5                           0x314
#define CORE0_A6                           0x318
#define CORE0_A7                           0x31C

#define CORE0_DCSR                         0x400
#define CORE0_SR                           0x404
#define CORE0_IDR                          0x408
#define CORE0_DSTART                       0x40C
#define CORE0_DQSTR                        0x41C
#define CORE0_PC                           0x420

#define CORE0_DCSR_PI                      BIT(0)
#define CORE0_DCSR_SE                      BIT(1)
#define CORE0_DCSR_BRK                     BIT(2)
#define CORE0_DCSR_STOP                    BIT(3)
#define CORE0_DCSR_RUN                     BIT(14)

/* Registers related to whole Velcore2 */
#define MASKR_ELCORE                       0x1000
#define QSTR_ELCORE                        0x1004
#define CSR_ELCORE                         0x1008
#define STAT_ELCORE                        0x1018
#define CTR_CLK                            0x1020
#define MASKR_ACC                          0x1080
#define QSTR_ACC                           0x1084

#define HWSGBM_INTS                        GENMASK(30, 26)


#define MASKR_CORE0_STOP                   BIT(0)
#define MASKR_CORE0_PI                     BIT(8)
#define MASKR_CORE0_BAD                    BIT(16)
#define QSTR_CORE0_STOP                    BIT(0)

#define elcore_readl(port, reg) readl((port)->regs + reg)
#define elcore_writel(port, reg, value) writel((value), (port)->regs + reg)

#endif
