/*
 * HWSGBM driver - userspace header
 *
 * Copyright 2016 ELVEES NeoTek JSC
 * Author: Oleg Kitain <okitain@elvees.com>
 */

#ifndef _LINUX_HWSGBM_H
#define _LINUX_HWSGBM_H

#include <linux/v4l2-controls.h>

#define V4L2_FIELD_ALTERNATE_LR 33
#define V4L2_FIELD_LEFT 34
#define V4L2_FIELD_RIGHT 35

#define V4L2_CID_HWSGBM_BASE		(V4L2_CID_IMAGE_PROC_CLASS_BASE + 0x20)
#define V4L2_CID_HWSGBM_NOD		V4L2_CID_HWSGBM_BASE
#define V4L2_CID_HWSGBM_ACCUMULATION	(V4L2_CID_HWSGBM_BASE + 0x1)
#define V4L2_CID_HWSGBM_PEAK_FILTER	(V4L2_CID_HWSGBM_BASE + 0x2)
#define V4L2_CID_HWSGBM_MAX_PEAK_SIZE	(V4L2_CID_HWSGBM_BASE + 0x3)
#define V4L2_CID_HWSGBM_INTERPOLATION	(V4L2_CID_HWSGBM_BASE + 0x4)
#define V4L2_CID_HWSGBM_INTERPOLATION_RADIUS	(V4L2_CID_HWSGBM_BASE + 0x5)
#define V4L2_CID_HWSGBM_ANISOTROPIC_FILTER	(V4L2_CID_HWSGBM_BASE + 0x6)
#define V4L2_CID_HWSGBM_ISLAND_FILTER	(V4L2_CID_HWSGBM_BASE + 0x7)
#define V4L2_CID_HWSGBM_ISOTROPIC_FILTER	(V4L2_CID_HWSGBM_BASE + 0x8)
#define V4L2_CID_HWSGBM_MEDIAN_FILTER	(V4L2_CID_HWSGBM_BASE + 0x9)
#define V4L2_CID_HWSGBM_MEDIAN_FILTER_STAGES	(V4L2_CID_HWSGBM_BASE + 0xa)
#define V4L2_CID_HWSGBM_MEDIAN_REPLACE_INVALID_LOW  (V4L2_CID_HWSGBM_BASE + 0xb)
#define V4L2_CID_HWSGBM_MEDIAN_REPLACE_INVALID_HIGH (V4L2_CID_HWSGBM_BASE + 0xc)
#define V4L2_CID_HWSGBM_SOBEL_THRESHOLD	(V4L2_CID_HWSGBM_BASE + 0xd)
#define V4L2_CID_HWSGBM_PENALTY_FOR_SINGLE	(V4L2_CID_HWSGBM_BASE + 0xe)
#define V4L2_CID_HWSGBM_PENALTY_FOR_MULTIPLE	(V4L2_CID_HWSGBM_BASE + 0xf)
#define V4L2_CID_HWSGBM_MAX_LR_DIFFERENCE	(V4L2_CID_HWSGBM_BASE + 0x10)
#define V4L2_CID_HWSGBM_MEDIAN_REPLACE_VALID_LOW (V4L2_CID_HWSGBM_BASE + 0x11)
#define V4L2_CID_HWSGBM_MEDIAN_REPLACE_VALID_HIGH (V4L2_CID_HWSGBM_BASE + 0x12)

#endif /* _LINUX_HWSGBM_H */
